<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_10</title>
</head>
<body>
    <h1>Capitulo 10</h1>
    <a>Ejercicio 5</a>

    <script>

        const buscarIndice = (arr, low, high, x) => {
            
            if (low > high) {
                return -1;
            }

            let mid = Math.floor((low + high) / 2);
            if (arr[mid] === "") {
                let left = mid - 1,
                   right = mid + 1;

                while (true) {                    
                    if (left < low && right > high) {
                        return -1;
                    }
                    if (left >= low && arr[left] != "") {
                        mid = left;
                        break;
                    } else if (right <= high && arr[right] != "") {
                        mid = right;
                        break;
                    }
                    left--;
                    right++;
                }
            }
            
            if (arr[mid] === x) {
                return mid;
            } else if (arr[mid] > x) {
                return buscarIndice(arr, low, mid - 1, x);
            } else {
                return buscarIndice(arr, mid + 1, high, x);
            }
        }

        const busquedaOrdenada = (arr, x, n) => {
            return buscarIndice(arr, 0, n - 1, x);
        }
            
 
        let arr = ["at", "", "", "", "ball", "", "", "car", "", "", "dad", "", ""];
        let x = "dad",
            n = x.length,
        index = busquedaOrdenada(arr, x, n);

        if (index != -1) {
            console.log(`"${x}" fue encontrada en la matriz ${index}`);
        } else {
            console.log(`"${x}" NO fue encontrada en la matriz`);
        }
 
        
        
</script>
    
</body>
</html>